package com.github.polpetta.mezzotre.i18n;

import java.util.Locale;
import javax.inject.Inject;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.runtime.resource.loader.JarResourceLoader;
import org.apache.velocity.tools.Scope;
import org.apache.velocity.tools.ToolContext;
import org.apache.velocity.tools.ToolManager;
import org.apache.velocity.tools.config.FactoryConfiguration;
import org.apache.velocity.tools.config.ToolConfiguration;
import org.apache.velocity.tools.config.ToolboxConfiguration;

public class LocalizedMessageFactory {

  private final VelocityEngine velocityEngine;

  @Inject
  public LocalizedMessageFactory(VelocityEngine velocityEngine) {
    this.velocityEngine = velocityEngine;
  }

  public ToolManager create(Locale locale) {

    //    properties.setProperty("file.resource.loader.class", FileResourceLoader.class.getName());.

    final ToolManager toolManager = new ToolManager();
    toolManager.setVelocityEngine(velocityEngine);
    final FactoryConfiguration factoryConfiguration = new FactoryConfiguration();
    final ToolboxConfiguration toolboxConfiguration = new ToolboxConfiguration();
    toolboxConfiguration.setScope(Scope.REQUEST);
    final ToolConfiguration toolConfiguration = new ToolConfiguration();
    toolConfiguration.setClassname(LocalizedTool.class.getName());
    toolConfiguration.setProperty("file.resource.loader.class", JarResourceLoader.class.getName());
    toolConfiguration.setProperty(ToolContext.LOCALE_KEY, locale);
    toolConfiguration.setProperty(LocalizedTool.BUNDLES_KEY, "i18n/message");
    toolboxConfiguration.addTool(toolConfiguration);
    factoryConfiguration.addToolbox(toolboxConfiguration);
    toolManager.configure(factoryConfiguration);
    return toolManager;
  }
}
