package com.github.polpetta.mezzotre.telegram.command.di;

import com.github.polpetta.mezzotre.telegram.command.Executor;
import com.github.polpetta.mezzotre.telegram.command.Start;
import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import java.util.Set;
import javax.inject.Named;
import javax.inject.Singleton;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.runtime.RuntimeConstants;
import org.apache.velocity.runtime.resource.loader.ClasspathResourceLoader;

public class Command extends AbstractModule {
  @Provides
  @Singleton
  @Named("commands")
  public Set<Executor> getCommandExecutors(Start start) {
    return Set.of(start);
  }

  @Provides
  public VelocityEngine getVelocityEngine() {
    final VelocityEngine velocityEngine = new VelocityEngine();
    velocityEngine.setProperty(RuntimeConstants.RESOURCE_LOADER, "classpath");
    velocityEngine.setProperty(
        "classpath.resource.loader.class", ClasspathResourceLoader.class.getName());
    velocityEngine.init();
    return velocityEngine;
  }
}
