package com.github.polpetta.mezzotre.util;

import java.util.UUID;
import javax.inject.Singleton;

/**
 * Simple UUID generator wrapper to make this code easily mockable in tests. It doesn't have any
 * other purpose
 *
 * @author Davide Polonio
 * @since 1.0-SNAPSHOT
 */
@Singleton
public class UUIDGenerator {

  /**
   * Generate a standard Java {@link UUID}
   *
   * @return a {@link UUID}
   */
  public UUID generate() {
    return UUID.randomUUID();
  }

  /**
   * Convenience method to get a {@link UUID} directly as {@link String}
   *
   * @return a {@link UUID} as {@link String}
   */
  public String generateAsString() {
    return UUID.randomUUID().toString();
  }
}
