package com.github.polpetta.mezzotre.util.di;

import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import java.util.concurrent.ForkJoinPool;
import javax.inject.Named;
import javax.inject.Singleton;

public class ThreadPool extends AbstractModule {
  @Provides
  @Singleton
  @Named("eventThreadPool")
  public Executor getEventExecutor() {
    return ForkJoinPool.commonPool();
  }

  @Provides
  @Singleton
  @Named("longJobThreadPool")
  public Executor getLongJobExecutor() {
    return Executors.newCachedThreadPool();
  }
}
